/****
 *
 * Exemplo: No Testar Ocorrncia de Erro com ferror()
 *
 * Seo: D.6.10
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *stream;
   int   c;

      /* Abre o arquivo somente para leitura */
   stream = fopen("Tudor.txt", "r");

   if (!stream) {
      printf("\nNao foi possivel abrir arquivo\n");
      return 1;
   }

      /* Gera uma condio de erro    */
      /* tentando escrever no arquivo */
   fputc('A', stream);

   printf("\n\t*** Primeira tentativa de leitura ***\n");

   c = fgetc(stream);

      /* Verifica se o final de arquivo foi atingido */
   if (feof(stream)) {
         printf("\n\t>>> Final do arquivo atingido\n");
   } else if (ferror(stream)) { /* Ocorreu erro */
      printf("\n\t>>> Erro na leitura do arquivo\n");
   } else { /* No ocorreu nenhuma irregularidade */
      printf( "\n\t>>> Primeiro caractere do arquivo: "
              "%c\n", c );
   }

      /* Verifica se h alguma sinalizao */
      /* de erro ou de final de arquivo    */
   if(ferror(stream) || feof(stream)) {
         /* Zera indicadores de erro */
         /* e de final de arquivo    */
      clearerr(stream);
   } else { /* O caractere j foi lido e */
            /* no h mais nada a fazer  */
      fclose(stream);
      return 0;
   }

   printf("\n\t*** Segunda tentativa de leitura ***\n");

   c = fgetc(stream);

      /* Verifica se o final de arquivo foi atingido */
   if (feof(stream)) { /* Final de arquivo foi atingido */
         printf("\n\t>>> Final do arquivo atingido\n");
   } else if (ferror(stream)) { /* Ocorreu erro */
      printf("\n\t>>> Erro na leitura do arquivo\n");
   } else { /* No ocorreu nenhuma irregularidade */
      printf( "\n\t>>> Primeiro caractere do arquivo: "
              "%c\n", c );
   }

   fclose(stream);

   return 0;
}

/****************** Resultado do Programa ******************

GCC/Windws XP:
=============

        *** Primeira tentativa de leitura ***

        >>> Erro na leitura do arquivo

        *** Segunda tentativa de leitura ***

        >>> Primeiro caractere do arquivo: e

Borland C++ 5.5/Windws XP:
=========================

        *** Primeira tentativa de leitura ***

        >>> Erro na leitura do arquivo

        *** Segunda tentativa de leitura ***

        >>> Primeiro caractere do arquivo: H

***********************************************************/
