/****
 *
 * Ttulo: Sequncia de Fibonnaci
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Gera uma sequncia de Fibonnaci com n termos
 *
 * Entrada: O nmero de termos da sequncia
 *
 * Sada: A sequncia de Fibonnaci mencionada
 *
 ****/

   /* Permite usar funes de biblioteca */
#include <stdio.h>   /* Funo printf()    */
#include "leitura.h" /* Funo LeInteiro() */

int main(void) /* Aqui comea a execuo do programa */
{
      /* Declaraes de variveis */
   int antecedente1, antecedente2,
       atual, nTermos, i;

      /* L o nmero de termos da sequncia */
   printf( "\nDigite o numero de termos da sequencia "
           "(pelo menos 2): " );
   nTermos = LeInteiro();

      /* Verifica se o nmero de */
      /* termos  menor do que 2 */
   if(nTermos < 2) {
      printf( "O numero de termos nao pode ser menor "
              "do que 2" );
   } else {
         /* Inicia os dois primeiros termos da srie */
      antecedente1 = 1;
      antecedente2 = 1;

         /* Exibe os dois primeiros termos da srie */
      printf("\n%d, %d", antecedente1, antecedente2);

         /* Gera e imprime os termos da seqncia a */
         /* partir do terceiro at o n-simo termo  */

         /* Inicia o ndice do prximo termo da seqncia */
      i = 3;

      while (i <= nTermos) {
            /* Atualiza o termo corrente com a */
            /* soma dos seus dois antecedentes */
         atual = antecedente1 + antecedente2;

         printf(", %d", atual); /* Exibe o termo corrente */

            /* Atualiza os termos antecedentes */
         antecedente1 = antecedente2;
         antecedente2 = atual;

         i =  i + 1; /* Incrementa ndice do prximo termo */
      }
   }

      /* Encerra o programa informando o sistema */
      /* operacional que no houve erro          */
   return 0;
}

/******************* Exemplo de Execuo ******************

Digite o numero de termos da sequencia (pelo menos 2): 5

1, 1, 2, 3, 5

**********************************************************/
