/****
 *
 * Ttulo: Converso de Celsius para Fahrenheit
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 14/06/2012
 * ltima modificao: 14/06/2012
 *
 * Descrio: Apresenta na tela uma tabela de converso
 *            de graus Celsius para Fahrenheit
 *
 * Entrada: Nada
 *
 * Sada: Tabela de converso de Celsius para Fahrenheit
 *
 ****/

#include <stdio.h>

/****
 *
 * main(): Apresenta na tela uma tabela de converso
 *         de graus Celsius para Fahrenheit
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int c; /* Temperatura em Celsius */

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa cria uma tabela de conversao"
           "\n\t>>> de Celsius para Fahrenheit\n" );

      /* Apresenta o cabealho da tabela */
      /* com uma linha de embelezamento  */
   printf("\nCelsius\tFahrenheit"
          "\n=======\t==========\n");

      /* A frmula de transformao de graus Celsius */
      /* em graus Fahrenheit : F = 1.8*C + 32, na   */
      /* qual F  a temperatura em Fahrenheit e C   */
      /* a temperatura em Celsius.                   */
   for (c = 0; c <= 100; c = c + 5) {
         /* Observe o efeito dos especificadores */
         /* de formato de printf() na exibio   */
      printf( "\n  %3d\t  %5.1f", c, 1.8*c + 32 );
   }

   putchar('\n'); /* Embelezamento apenas */

      /* Despede-se do usurio */
   printf( "\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/****************** Resultado do programa ******************

        >>> Este programa cria uma tabela de conversao
        >>> de Celsius para Fahrenheit

Celsius Fahrenheit
======= ==========

    0      32.0
    5      41.0
   10      50.0
   15      59.0
   20      68.0
   25      77.0
   30      86.0
   35      95.0
   40     104.0
   45     113.0
   50     122.0
   55     131.0
   60     140.0
   65     149.0
   70     158.0
   75     167.0
   80     176.0
   85     185.0
   90     194.0
   95     203.0
  100     212.0

        >>> Obrigado por usar este programa.

***********************************************************/
