/****
 *
 * Ttulo: Clculo de Dvidas
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 14/06/2012
 * ltima modificao: 14/06/2012
 *
 * Descrio: Calcula dvidas usando juros compostos
 *
 * Entrada: Taxa de juros e a quantia emprestada
 *
 * Sada: Dvida ano a ano, com 5 anos como limite
 *
 ****/

#include <stdio.h>   /* printf() */
#include <math.h>    /* pow()    */
#include "leitura.h" /* LeReal() */

/****
 *
 * main(): Calcula dvidas usando juros compostos
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int    periodo;
   double juros, quantia, divida;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa calcula a divida do"
           "\n\t>>> usuario que fez um emprestimo usando"
           "\n\t>>> a formula de juros compostos.\n" );

      /* L a quantia que usurio tomou emprestado */
   printf("\nQuanto voce tomou emprestado (R$)? ");
   quantia = LeReal();

      /* L a taxa de juros do emprstimo em  */
      /* percentagem. Note como o smbolo '%' */
      /*  escrito no string de formatao.   */
   printf("\nQuanto e' a taxa de juros (%%)? ");
   juros = LeReal();

      /* Calcula os juros sem percentagem */
   juros = juros/100;

      /* Apresenta o prejuzo do usurio a cada ano */
   for (periodo = 1; periodo <= 5; ++periodo) {
      divida = quantia*pow(1 + juros, periodo);
      printf( "\nApos %d anos voce devera': "
              "R$%5.2f", periodo, divida );
   }

   putchar('\n'); /* Embelezamento */

      /* Despede-se do usurio */
   printf( "\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa calcula a divida do
        >>> usuario que fez um emprestimo usando
        >>> a formula de juros compostos.

Quanto voce tomou emprestado (R$)? 1000

Quanto e' a taxa de juros (%)? 31

Apos 1 anos voce devera': R$1310.00
Apos 2 anos voce devera': R$1716.10
Apos 3 anos voce devera': R$2248.09
Apos 4 anos voce devera': R$2945.00
Apos 5 anos voce devera': R$3857.95

        >>> Obrigado por usar este programa.

***********************************************************/
