/****
 *
 * Ttulo: Tringulos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 15/06/2012
 * ltima modificao: 15/06/2012
 *
 * Descrio: Verifica se trs valores reais constituem
 *            os lados de um tringulo
 *
 * Entrada: Trs valores de ponto flutuante
 *
 * Sada: Uma mensagem informando se os valores
 *        constituem os lados de um tringulo
 *
 ****/

#include <stdio.h>   /* printf() */
#include "leitura.h" /* LeReal() */

/****
 *
 * main(): Verifica se trs valores reais constituem
 *         os lados de um tringulo
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   double x, y, z;

   printf( "\n>>> Este programa verifica se tres "
           "\n>>> valores reais podem constituir "
           "\n>>> os lados de um triangulo.\n\n" );

   /*                                                  */
   /* L os valores candidatos a lados de um tringulo */
   /*                                                  */

   printf("\nDigite o primeiro valor: ");
   x = LeReal();

   printf("\nDigite o segundo valor: ");
   y = LeReal();

   printf("\nDigite o terceiro valor: ");
   z = LeReal();

      /* Verifica se os valores introduzidos  */
      /* satisfazem a desigualdade triangular */
   if (x <= 0 || y <= 0 || z <= 0) {
      printf("\nPelo menos um valor nao e' positivo.\n");
   } else if ( x < y + z && y < x + z && z < y + x ) {
      printf( "\nOs valores constituem os "
              "lados de um triangulo.\n" );
   } else {
      printf( "\nOs valores NAO constituem "
              "os lados de um triangulo.\n" );
   }

   return 0;
}

/******************* Exemplo de Execuo ******************

>>> Este programa verifica se tres
>>> valores reais podem constituir
>>> os lados de um triangulo.

Digite o primeiro valor: 3

Digite o segundo valor: 4

Digite o terceiro valor: 5

Os valores constituem os lados de um triangulo.

**********************************************************/
