/****
 *
 * Ttulo: Anos Bissextos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 21/06/2012
 * ltima modificao: 21/06/2012
 *
 * Descrio: Verifica se cada nmero inteiro introduzido
 *            pelo usurio representa um ano bissexto
 *
 * Entrada: Valores inteiros positivos ou zero
 *          para encerrar o programa
 *
 * Sada: Mensagem indicando se o ano  bissexto ou no
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

   /* Anos bissextos tais como so conhecidos hoje */
   /* comearam a ser contados a partir de 1753    */
#define MENOR_ANO 1753

/****
 *
 * main(): Verifica se cada nmero inteiro introduzido
 *         pelo usurio representa um ano bissexto
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int a;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa verifica se cada numero"
           "\n\t>>> inteiro introduzido pelo usuario"
           "\n\t>>> representa um ano bissexto.\n"
           "\n\t>>> Digite zero para encerrar o programa.\n" );

      /* L cada valor introduzido pelo usurio e       */
      /* informa se trata-se de um ano bissexto ou no. */
      /* O lao encerra quando o usurio digitar zero.  */
   while (1) {
         /* Faz a leitura */
      printf("\n\t>>> Digite um ano maior do que ou igual\n"
             "\t>>> a %d (0 encerra o programa) > ", MENOR_ANO);
      a = LeInteiro();

      if (!a) { /* Se a == 0, encerra o lao */
         break;
      }

      if (a < MENOR_ANO) {
         printf( "\n\t>>> O ano deve ser maior do que ou "
                 "igual a %d\n", MENOR_ANO );
      } else {
            /* Informa se o ano  bissexto ou no */
         printf("\n\t>>> O ano %se' bissexto\n",
                !(a%400) || (!(a%4) && a%100) ? "" : "NAO ");
      }
   }

      /* Despede-se do usurio */
   printf( "\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa verifica se cada numero
        >>> inteiro introduzido pelo usuario
        >>> representa um ano bissexto.

        >>> Digite zero para encerrar o programa.

        >>> Digite um ano maior do que ou igual
        >>> a 1753 (0 encerra o programa) > 1500

        >>> O ano deve ser maior do que ou igual a 1753

        >>> Digite um ano maior do que ou igual
        >>> a 1753 (0 encerra o programa) > 1996

        >>> O ano e' bissexto

        >>> Digite um ano maior do que ou igual
        >>> a 1753 (0 encerra o programa) > 0

        >>> Obrigado por usar este programa.

***********************************************************/
