/****
 *
 * Ttulo: Maior Valor do Tipo int
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 14/06/2012
 * ltima modificao: 14/06/2012
 *
 * Descrio: Determina qual  o maior valor do tipo int e
 *            mostra como detectar ocorrncia de overflow
 *            numa operao inteira
 *
 * Entrada: No h
 *
 * Sada: Uma mensagem indicando se o nmero  primo ou no
 *
 ****/

#include <stdio.h>   /* Entrada e sada  */
#include <limits.h>  /* Limites inteiros */

/****
 *
 * main(): Determina qual  o maior valor do tipo int e mostra
 *         como detectar overflow numa operao inteira
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int maiorInt = 0;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa determina qual e' o maior"
           "\n\t>>> valor do tipo int e mostra como detectar"
           "\n\t>>> overflow numa operacao inteira.\n" );

      /* Apresenta uma mensagem para o usurio */
      /* saber que o programa est vivo        */
   printf("\nEncontrando o maior valor do tipo int...");

      /* Encontra o maior valor do tipo int. Seja */
      /* paciente e no digite [CTRL] + C, esta   */
      /* operao leva um tempo considervel.     */
   while (maiorInt + 1 > maiorInt) {
      maiorInt++;
   }

      /* Os valores exibidos a seguir devem ser iguais. */
      /* Caso contrrio, o programa est incorreto.     */
   printf("\n\nMaior valor do tipo int = %d", maiorInt);
   printf("\n                INT_MAX = %d\n", INT_MAX);

   return 0;
}

/****************** Resultado do Programa *****************

        >>> Este programa determina qual e' o maior
        >>> valor do tipo int e mostra como detectar
        >>> overflow numa operacao inteira.

Encontrando o maior valor do tipo int...

Maior valor do tipo int = 2147483647
                INT_MAX = 2147483647

**********************************************************/
