/****
 *
 * Ttulo: Sorteando Bnus para o Cliente
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 23/06/2012
 * ltima modificao: 23/06/2012
 *
 * Descrio: Sorteia para o usurio um bnus em reais entre
 *            MENOR_BONUS e MAIOR_BONUS de acordo com um
 *            valor inteiro introduzido como entrada
 *
 * Entrada: Um valor inteiro lido via teclado
 *
 * Sada: Um valor inteiro aleatrio entre MENOR_BONUS e
 *        MAIOR_BONUS
 *
 ****/

#include <stdio.h>   /* printf()         */
#include <stdlib.h>  /* rand() e srand() */
#include "leitura.h" /* LeInteiro()      */

#define MENOR_BONUS 1
#define MAIOR_BONUS 10

/****
 *
 * main(): Sorteia para o usurio um bnus em reais entre
 *         MENOR_BONUS e MAIOR_BONUS de acordo com um valor
 *         inteiro introduzido como entrada
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int sorte, bonus;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa sorteia um premio"
           "\n\t>>> entre R$%d e R$%d. Boa sorte!\n",
           MENOR_BONUS, MAIOR_BONUS );

   printf("\n\t>>> Digite seu numero de sorte > ");
   sorte = LeInteiro();

      /* Alimenta o gerador de nmeros aleatrios */
      /* com o nmero de sorte do usurio         */
   srand(sorte);

      /* Efetua o sorteio */
   bonus = rand()%(MAIOR_BONUS - MENOR_BONUS + 1) + MENOR_BONUS;

   printf( "\a\n\t>>> Parabens! Voce acaba de ganhar %d "
           "rea%s!!!\n", bonus, bonus == 1 ? "l" : "is");

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa sorteia um premio
        >>> entre R$1 e R$10. Boa sorte!

        >>> Digite seu numero de sorte > 21

        >>> Parabens! Voce acaba de ganhar 8 reais!!!

***********************************************************/
