/****
 *
 * Ttulo: Somando Positivos e Contando Negativos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: L um nmero indeterminado de valores
 *            inteiros, soma aqueles que so positivos
 *            e conta quantos valores negativos foram
 *            introduzidos. A entrada de dados encerra
 *            quando zero for introduzido.
 *
 * Entrada: Valores inteiros
 *
 * Sada: Soma dos valores positivos e a quantidade
 *        de valores negativos introduzidos.
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

/****
 *
 * main(): L um nmero indeterminado de valores inteiros, soma
 *         aqueles que so positivos e conta quantos valores
 *         negativos foram introduzidos. A entrada de dados
 *         encerra quando zero for introduzido.
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int valor, /* Valor inteiro recentemente lido */
       soma = 0, /* Soma dos valores positivos */
       negativos = 0; /* Quantidade de valores negativos */

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa soma os valores positivos e a"
           "\n\t>>> quantidade de valores negativos digitados."
           "\n\t>>> Zero encerra a entrada de dados.\n" );

      /* O lao encerra quando for lido zero */
   while (1) {
      printf("\n\t>>> Digite um valor inteiro: ");
      valor = LeInteiro();

         /* Se o usurio digitar zero, encerra o lao */
      if (valor == 0) {
         break;
      }

         /* Se o valor for negativo, acrescenta 1  */
         /* contagem. Se ele for positivo, soma-o.  */
      if (valor < 0) {
         ++negativos;
      } else {
         soma = soma + valor;
      }
   }

      /* Apresenta o resultado */
   printf("\n\t>>> Soma dos valores positivos: %d", soma);
   printf( "\n\t>>> Valores negativos: %d\n", negativos );

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa soma os valores positivos e a
        >>> quantidade de valores negativos digitados.
        >>> Zero encerra a entrada de dados.

        >>> Digite um valor inteiro: 2

        >>> Digite um valor inteiro: 1

        >>> Digite um valor inteiro: -1

        >>> Digite um valor inteiro: -3

        >>> Digite um valor inteiro: 4

        >>> Digite um valor inteiro: -4

        >>> Digite um valor inteiro: 0

        >>> Soma dos valores positivos: 7
        >>> Valores negativos introduzidos: 3

***********************************************************/
