/****
 *
 * Ttulo: Fatorando Nmeros Inteiros Positivos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 18/07/2012
 * ltima modificao: 18/07/2012
 *
 * Descrio: Determina os fatores de cada nmero
 *            inteiro positivo recebido como entrada
 *
 * Entrada: Nmeros inteiros
 *
 * Sada: Se o nmero introduzido for positivo, todos os fatores
 *        do nmero. Se o nmero for negativo ou zero, o programa
 *         encerrado com uma mensagem de despedida.
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

/****
 *
 * main(): Determina os fatores de cada nmero
 *         inteiro positivo recebido como entrada
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int numero,
       possivelFator, /* Um candidato a fator do nmero */
       faltaFatorar; /* Parte do nmero que falta fatorar */

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa apresenta fatoracoes"
           "\n\t>>> de numeros inteiros positivos.\n" );

      /* O lao encerra quando for introduzido */
      /* um nmero que no  positivo          */
   while (1) {
      printf("\n\t>>> Numero positivo que sera' fatorado: ");
      numero = LeInteiro();

      if (numero <= 0) {
         printf("\n\t>>> O numero deveria ser positivo\n");
         break;
      }

         /* O primeiro candidato a fator  2  */
         /* pois 1  fator de qualquer nmero */
      possivelFator = 2;

         /* O nmero ainda no foi fatorado */
      faltaFatorar = numero;

      printf("\n\t>>> Fatores de %d:\n\n\t\t> ", numero);

         /* No mximo, o divisor de um nmero  igual  raiz  */
         /* quadrada do nmero. Portanto, se o quadrado de um */
         /* possvel divisor for maior do que o nmero, ele   */
         /* no tem mais divisores e o lao  encerrado.      */
      while(possivelFator*possivelFator <= faltaFatorar) {
            /* Verifica se o candidato a  */
            /* fator  realmente um fator */
         if(faltaFatorar%possivelFator == 0) {
               /* Encontrado um fator */
            printf("%d * ", possivelFator);

               /* Atualiza o valor que falta fatorar,        */
               /* considerando-o como o resultado da diviso */
               /* do nmero pelo ltimo fator encontrado     */
            faltaFatorar = faltaFatorar/possivelFator;

            continue; /* O resto do lao no ser executado */
         }

         /*                                    */
         /* O ltimo candidato no  um fator. */
         /* Ento, tenta-se outro candidato.   */
         /*                                    */

            /* Se o ltimo candidato foi 2, o prximo */
            /* candidato ser 3. Caso contrrio,      */
            /* soma-se 2 ao ltimo candidato.         */
         if(possivelFator == 2) {
            possivelFator = 3;
         } else {
            possivelFator = possivelFator + 2;
         }
      }

         /* O ltimo fator  o que faltou fatorar */
      printf("%d\n", faltaFatorar);
   }

      /* Despede-se do usurio */
   printf( "\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/******************* Exemplo de Execuo ******************

        >>> Este programa apresenta fatoracoes
        >>> de numeros inteiros positivos.

        >>> Numero positivo que sera' fatorado: 1000

        >>> Fatores de 1000:

                > 2 * 2 * 2 * 5 * 5 * 5

        >>> Numero positivo que sera' fatorado: 0

        >>> O numero deveria ser positivo

        >>> Obrigado por usar este programa.

**********************************************************/
