/****
 *
 * Exemplo: Interao com Lao Infinito
 *
 * Seo: 5.11.4
 *
 ****/

#include <stdio.h>   /* Entrada e sada */
#include "leitura.h" /* LeituraFacil    */

/****
 *
 * ApresentaMenu(): Apresenta um menu de opes
 *
 * Parmetros: nenhum
 *
 * Retorno: Nada
 *
 ****/
void ApresentaMenu(void)
{
   printf( "\n\n\t*** Opcoes ***\n"
           "\n\t1 - Opcao 1"
           "\n\t2 - Opcao 2"
           "\n\t3 - Opcao 3"
           "\n\t4 - Opcao 4"
           "\n\t5 - Encerra o programa\n" );
}

/****
 *
 * Opcao1(): Operao fictcia do programa
 *
 * Parmetros: nenhum
 *
 * Retorno: Nada
 *
 ****/
void Opcao1(void)
{
   printf("\n\t>>> Voce escolheu a opcao 1\n");
}

/****
 *
 * Opcao2(): Operao fictcia do programa
 *
 * Parmetros: nenhum
 *
 * Retorno: Nada
 *
 ****/
void Opcao2(void)
{
   printf("\n\t>>> Voce escolheu a opcao 2\n");
}

/****
 *
 * Opcao3(): Operao fictcia do programa
 *
 * Parmetros: nenhum
 *
 * Retorno: Nada
 *
 ****/
void Opcao3(void)
{
   printf("\n\t>>> Voce escolheu a opcao 3\n");
}

/****
 *
 * Opcao4(): Operao fictcia do programa
 *
 * Parmetros: nenhum
 *
 * Retorno: Nada
 *
 ****/
void Opcao4(void)
{
   printf("\n\t>>> Voce escolheu a opcao 4\n");
}

/****
 *
 * main(): Implementa uma interao dirigida por menu
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int opcao;

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa faz isto, isso e aquilo."
           "\n\t>>> Escolha a opcao 5 para encerra-lo.\n" );

      /* O lao encerra quando o     */
      /* usurio escolhe a opo '5' */
   while (1) {
      ApresentaMenu();

         /* L a opo do usurio */
      printf("\n\t>>> Escolha sua opcao: ");
      opcao = LeOpcao("12345");

         /* Se o usurio escolher a  */
         /* opo 5, encerra  o lao */
      if (opcao == '5') {
         break; /* Encerra o lao while */
      }

         /* Processa as demais opes */
      switch (opcao) {
         case '1':
            Opcao1();
            break;
         case '2':
            Opcao2();
            break;
         case '3':
            Opcao3();
            break;
         case '4':
            Opcao4();
            break;
         default:
            printf("\nEste programa contem um erro!!!");
            break;
      } /* switch */
   } /* while */

      /* Despede-se do usurio */
   printf( "\n\t>>> Obrigado por usar este programa.\n");

   return 0;
}

/******************* Exemplo de Execuo ******************

        >>> Este programa faz isto, isso e
        >>> aquilo. Escolha a opcao 5 para
        >>> encerra-lo.


        *** Opcoes ***

        1 - Opcao 1
        2 - Opcao 2
        3 - Opcao 3
        4 - Opcao 4
        5 - Encerra o programa

        >>> Escolha sua opcao: 1

        >>> Voce escolheu a opcao 1


        *** Opcoes ***

        1 - Opcao 1
        2 - Opcao 2
        3 - Opcao 3
        4 - Opcao 4
        5 - Encerra o programa

        >>> Escolha sua opcao: 5

        >>> Obrigado por usar este programa.

**********************************************************/
