/****
 *
 * Ttulo: Leitura de Nmeros Naturais
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 02/06/2012
 * ltima modificao: 02/06/2012
 *
 * Descrio: L nmeros naturais (i.e., inteiros no negativos)
 *            permitindo ao usurio novas chances de corrigir
 *            algum engano cometido.
 *
 * Entrada: Valores inteiros no negativos introduzidos via teclado
 *
 * Sada: Uma mensagem indicando se o nmero introduzido
 *         vlido ou no
 *
 ****/

#include <stdio.h>   /* Entrada e sada */
#include "leitura.h" /* LeituraFacil    */

/****
 *
 * LeNatural(): L um nmero natural (i.e., um nmero
 *              inteiro no negativo)
 *
 * Parmetros: Nenhum
 *
 * Retorno: O nmero natural lido
 *
 ****/
int LeNatural(void)
{
   int numNatural; /* O nmero a ser lido */

   numNatural = LeInteiro(); /* Primeira tentativa */

   while(numNatural < 0) {
      printf( "\a\n\t>>> Valor invalido. "
              "Tente novamente <<<\n\t> " );
      numNatural = LeInteiro(); /* Faz nova tentativa */
   }

   return numNatural;
}

/****
 *
 * main(): Testa a funo LeNatural()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int num;

      /* Apresenta o programa ao usurio */
      /* e explica se funcionamento      */
   printf( "\n\t>>> Este programa le um numero natural"
           "\n\t>>> e apresenta-o na tela.\n" );


      /* Fora o usurio a digitar um nmero natural */
   printf( "\n\t>>> Digite um numero inteiro que "
            "nao seja negativo:\n\t> " );
   num = LeNatural(); /* L o nmero */

      /* Apresenta o nmero digitado */
   printf("\n\t>>> Voce digitou %d\n", num);

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa le um numero natural
        >>> e apresenta-o na tela.

        >>> Digite um numero inteiro que nao seja negativo:
        > -1

        >>> Valor invalido. Tente novamente <<<
        > 0

        >>> Voce digitou 0

***********************************************************/
