/****
 *
 * Ttulo: Desenhando Quadrados
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 02/06/2012
 * ltima modificao: 02/06/2012
 *
 * Descrio: Desenha quadrados na tela usando asteriscos
 *
 * Entrada: Um valor inteiro positivo representando o
 *          lado do quadrado
 *
 * Sada: O referido quadrado
 *
 ****/

#include <stdio.h>   /* printf() e putchar() */
#include "leitura.h" /* LeInteiro()          */

   /* Maior lado permitido para um quadrado */
#define MAIOR_LADO 20

/****
 *
 * main(): Desenha um quadrado de asteriscos
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int lado, /* Lado do quadrado */
       i, j;

      /* Apresenta o programa e explica seu funcionamento */
   printf("\n\t>>> Este programa desenha um quadrado de lado L."
          "\n\t>>> O valor de L deve ser um inteiro maior do"
          "\n\t>>> que 1 e menor do que %d.\n", MAIOR_LADO + 1);

      /* O lao encerra quando o valor digitado for vlido */
   while (1) {
      printf("\n>>> Digite o lado do quadrado:\n\t> ");
      lado = LeInteiro();

         /* Verifica se o valor  vlido */
      if (lado > 1 && lado <= MAIOR_LADO) {
         break; /* Valor  vlido. Encerra o lao. */
      }

         /* Valor digitado no  vlido */
      printf( "\a\n>>> O lado deve ser maior do que 1 e "
              "menor do que %d <<<\n", MAIOR_LADO + 1 );
   }

   printf("\n\t>>> Eis o seu quadrado:\n\n");

      /* Desenha a linha superior do quadrado */
   for (i = 1; i <= lado; ++i) {
      putchar('*');
   }

      /* Desenha as demais linhas */
   for (j = 2; j < lado; ++j) {
      putchar('\n'); /* Pula linha */
      putchar('*'); /* Primeira coluna */

         /* Da segunda coluna at a penltima */
         /* escreve espaos em branco         */
      for (i = 2; i < lado; ++i) {
         putchar(' ');
      }

      putchar('*'); /* ltima coluna */
   }

      /* Desenha a linha inferior do quadrado */
   putchar('\n'); /* Pula linha */
   for (i = 1; i <= lado; ++i) {
      putchar('*');
   }

   putchar('\n'); /* Apenas embelezamento */

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa desenha um quadrado de lado L.
        >>> O valor de L deve ser um inteiro maior do
        >>> que 1 e menor do que 21.

>>> Digite o lado do quadrado:
        > 5

        >>> Eis o seu quadrado:

*****
*   *
*   *
*   *
*****

***********************************************************/
