/****
 *
 * Exemplo: Uso de arrays como parmetros
 *
 * Seo: 7.9.2
 *
 ****/

#include <stdio.h>

/****
 *
 * ExibeArrayInts(): Apresenta um array de ints na tela
 *
 * Parmetros:
 *      ar[] (entrada) - array que ser apresentado
 *      tamanho (entrada) - nmero de elementos do array
 *
 * Retorno: Nada.
 *
 ****/
void ExibeArrayInts(const int ar[], int tamanho)
{
   int i;

      /* Se o nmero de elementos for menor do que ou */
      /* igual a zero, escreve as chaves e retorna    */
   if (tamanho <= 0) {
      printf("\n\t{ }\n");
      return;
   }

      /* Escreve abre-chaves */
   printf("\n\t{ ");

      /* Escreve do primeiro ao penltimo elemento */
   for (i = 0; i < tamanho - 1; ++i) {
      printf("%d, ", ar[i]);
   }

      /* Escreve o ltimo elemento separadamente para */
      /* que no haja uma vrgula sobrando ao final   */
   printf("%d }\n",  ar[tamanho - 1]);
}

void CopiaArray( int destino[], const int origem[],
                 int nElementos )
{
   int  i;

   for (i = 0; i < nElementos; i++) {
      destino[i] = origem[i];
   }
}

int main(void)
{
   int ar1[5] = {5, 2, 6, 8, 0},
       ar2[5];

   printf("\n\n   ****** Array Original ******\n\n");
   ExibeArrayInts(ar1, 5);

   CopiaArray(ar2, ar1, 5);

   printf("\n\n   ****** Array Copiado ******\n\n");
   ExibeArrayInts(ar2, 5);

   return 0;
}

/****************** Resultado do Programa *****************

   ****** Array Original ******


        { 5, 2, 6, 8, 0 }


   ****** Array Copiado ******


        { 5, 2, 6, 8, 0 }

**********************************************************/
