/****
 *
 * Ttulo: Maior, Menor e Mdia de Elementos de um Array
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/04/2012
 * ltima modificao: 22/04/2012
 *
 * Descrio: Determina o maior, o menor a mdias dos
 *            elementos de um array de inteiros
 *
 * Entrada: Nada
 *
 * Sada: O maior, o menor e a mdia dos elementos
 *        de um array de ints
 *
 ****/

#include <stdio.h>

/****
 *
 * main(): Determina o maior, o menor e as mdias inteira
 *         e real dos elementos de um array de inteiros
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int ar[] = {-1, 2, 0, -2, 3, 8, 10, -1, 11, 4};
   int i, /* Usada para acessar cada elemento do array */
       maior, /* Armazenar o maior valor */
       menor, /* Armazenar o menor valor */
       soma,  /* Soma dos elementos do array */
       nElem; /* Nmero de elementos do array */

      /* Assume-se inicialmente que o maior */
      /* e o menor valores so iguais ao    */
      /* primeiro elemento do array         */
   maior = menor = ar[0];

      /* Inicia a soma com zero, que */
      /*  elemento neutro da soma   */
   soma = 0;

      /* Calcula o nmero de elementos do array */
   nElem = sizeof(ar)/sizeof(ar[0]);

      /* Determina o maior, o menor e soma */
      /* dos elementos do array ar[]       */
   for (i = 0; i < nElem; ++i) {
         /* Se o elemento corrente for maior do que o */
         /* valor da varivel 'maior', essa varivel  */
         /* assume o valor do elemento corrente.      */
      if (ar[i] > maior) {
         maior = ar[i];
      }

         /* Se o elemento corrente for menor do que o */
         /* valor da varivel 'menor', essa varivel  */
         /* assume o valor do elemento corrente.      */
      if (ar[i] < menor) {
         menor = ar[i];
      }

         /* Acrescenta o corrente elemento */
         /*  soma acumulada               */
      soma = soma + ar[i];
   }

   printf("\n\t>>> Array <<<\n\n"); /* Embelezamento */

      /* Exibe o array */
   for (i = 0; i < nElem; ++i) {
      printf("%d  ", ar[i]);
   }

   printf("\n\n\t>>> Menor valor: %d", menor);
   printf("\n\t>>> Maior valor: %d", maior);
   printf("\n\t>>> Media Inteira: %d", soma/nElem);
   printf("\n\t>>> Media Real: %3.2f\n", (double) soma/nElem);

   return 0;
}

/****************** Resultado do Programa *****************

        >>> Array <<<

-1  2  0  -2  3  8  10  -1  11  4

        >>> Menor valor: -2
        >>> Maior valor: 11
        >>> Media Inteira: 3
        >>> Media Real: 3.40

**********************************************************/
