/****
 *
 * Ttulo: Ocorrncias de Dgitos num Nmero Inteiro Positivo
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 08/06/2012
 * ltima modificao: 08/06/2012
 *
 * Descrio: Determina a frequncia de ocorrncia
 *            de dgitos num nmero inteiro positivo
 *
 * Entrada: Um valores inteiro positivo
 *
 * Sada: Informao sobre quantas vezes cada dgito ocorre no nmero
 *
 ****/

#include <stdio.h>   /* printf()    */
#include "leitura.h" /* LeInteiro() */

   /* Nmero de dgitos na base decimal */
#define DIGITOS_BASE_DECIMAL  10

/****
 *
 * main(): Determina a frequncia de ocorrncia de dgitos num
 *         nmero inteiro positivo
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int i,
       num,     /* Armazena o nmero introduzido  */
       digito;  /* Armazena cada dgito do nmero */

   int digitos[DIGITOS_BASE_DECIMAL] = {0};
         /* Os ndices do array digitos[] representam os       */
         /* dgitos da base decimal e os elementos armazenaro */
         /* as ocorrncias dos dgitos.  importante iniciar   */
         /* todos os elementos com zero.                       */

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa determina a frequencia de "
           "ocorrencia \n\t>>> de digitos num numero inteiro"
           " positivo\n" );

   /*********************************************/
   /* Este programa no  amigvel ao usurio.  */
   /* Ou seja, se o usurio no digitar aquilo  */
   /* que o programa espera, ele  encerrado.   */
   /*********************************************/

      /* Tenta ler um valor vlido */
   printf("\n\t>>> Digite um numero positivo: ");
   num = LeInteiro();

      /* Este programa no tolera usurio chato */
   if (num <= 0) {
      printf( "\n\t>>> Voce deveria ter digitado um "
              "numero positivo. Bye.\n" );
      return 1;
   }

      /* Obtm cada dgito e incrementa o nmero de */
      /* ocorrncias do dgito no array digitos[]   */
   for (i = num; i > 0; i = i/10) {
      digito = i%10; /* Obtm o prximo dgito */
      ++digitos[digito]; /* Incrementa o nmero de       */
                         /* ocorrncias do dgito obtido */
   }

   /*                                           */
   /*     >>>>> Apresenta o resultado <<<<<     */
   /*                                           */

   printf( "\n>>> Ocorrencias de digitos em %d <<<\n", num );

   for (i = 0; i < 10; ++i) {
         /* Dgitos que no ocorrem no so exibidos */
      if (digitos[i]) {
         printf( "\n\t>>> O digito %d ocorre %d vez%s", i,
                 digitos[i], digitos[i] > 1 ? "es" : "" );
      }
   }

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa determina a frequencia de ocorrencia
        >>> de digitos num numero inteiro positivo

        >>> Digite um numero positivo: 223453265

>>> Ocorrencias de digitos em 223453265 <<<

        >>> O digito 2 ocorre 3 vezes
        >>> O digito 3 ocorre 2 vezes
        >>> O digito 4 ocorre 1 vez
        >>> O digito 5 ocorre 2 vezes
        >>> O digito 6 ocorre 1 vez

        >>> Obrigado por usar este programa.

***********************************************************/
