/****
 *
 * Ttulo: Mega-sena Gratuita (mas sem Premiao)
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 12/06/2012
 * ltima modificao: 12/06/2012
 *
 * Descrio: Brinca de loto com o usurio sem que
 *            ele tenha que gastar dinheiro  toa.
 *
 * Entrada: Valores inteiros entre 1 e 60 represtando
 *          nmeros de uma aposta e um valor entre 6 e
 *          10 que representa o nmero de apostas.
 *
 * Sada: Uma mensagem informando se o usurio foi
 *        sorteado ou no
 *
 * Observao:
 *
 ****/

/************************ Includes ************************/

#include <stdio.h>   /* Entrada e sada   */
#include <time.h>    /* Funo time()     */
#include <stdlib.h>  /* srand() e rand(() */
#include "leitura.h" /* LeituraFacil      */

/****************** Constantes Simblicas *****************/

#define NUMEROS_LOTO       6 /* Nmeros sorteados           */
#define MENOR_NUMERO_LOTO  1 /* O menor nmero da Mega-sena */
#define MAIOR_NUMERO_LOTO 60 /* O maior nmero da Mega-sena */
#define MAX_APOSTAS       15 /* Nmero mximo de apostas    */

/************************* Aluses ************************/

extern int LeIntEntre(int menor, int maior);
extern int EmArray(const int ar[], int tam, int num);

/****************** Definies de Funes *****************/

/****
 *
 * LeIntEntre(): L um nmero inteiro entre os valores
 *               especificados pelos parmetros
 *
 * Parmetros: menor (entrada): o menor valor permitido
 *             maior (entrada): o maior valor permitido
 *
 * Retorno: O nmero lido
 *
 * Observao: Esta funo assume que o primeiro parmetro
 *              o menor e o segundo parmetro  o maior
 *
 ****/
int LeIntEntre(int menor, int maior)
{
   int num;

   /* Volta para c a cada tentativa frustrada de leitura */
inicioLeitura:
      /* Apresenta prompt e faz uma tentativa de leitura */
   printf( "\n\t>>> Digite um valor inteiro entre %d e "
           "%d\n\t\t> ", menor, maior );
   num = LeInteiro();

      /* Verifica se o valor introduzido satisfaz os   */
      /* critrios especificados. Se no for o caso,   */
      /* apresenta uma mensagem informando o erro ao   */
      /* usurio, e faz uma nova tentativa de leitura. */
   if (num < menor || num > maior) {
      printf("\n\t>>> Valor invalido\n");
      goto inicioLeitura; /* No cria cdigo espaguete */
   }

      /* Seguramente, o nmero retornado */
      /* satisfaz as especificaes      */
   return num;
}

/****
 *
 * EmArray(): Verifica se um nmero inteiro encontra-se
 *            num array de inteiros
 *
 * Parmetros: ar[] (entrada): o array que ser pesquisado
 *             tam (entrada): nmero de elementos do array
 *             num (entrada): o nmero que ser procurado
 *
 * Retorno: ndice do nmero no array, se ele for encontrado
 *          -1, em caso contrrio
 *
 ****/
int EmArray(const int ar[], int tam, int num)
{
   int i;

      /* Compara cada elemento do array com o        */
      /* parmetro 'num'. Se for encontrado um       */
      /* elemento igual a 'num', retorna seu ndice. */
   for (i = 0; i < tam; ++i) {
      if (ar[i] == num) {
         return i; /* Encontrado um elemento igual */
      }
   }

      /* Valor recebido como parmetro */
      /* no foi encontrado no array   */
   return -1;
}


/****
 *
 * main():
 *   * L a quantidade de nmeros que o usurio apostar
 *   * L cada nmero que integra a aposta do usurio
 *   * Faz o sorteio da loteria
 *   * Compara a aposta do usurio com os nmeros sorteados
 *   * Informa o usurio se ele ganhou ou perdeu
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int    sorteio[NUMEROS_LOTO], /* Conter os nmeros */
                                 /* sorteados          */
          aposta[MAX_APOSTAS], /* Conter a aposta */
                               /* do usurio       */
          i,
          nApostas, /* Quantidade de nmeros  */
                    /* que o usurio apostar */
          num,  /* Um nmero de aposta do usurio */
          perdeu = 0; /* Indicar se o usurio */
                      /* foi sorteado ou no   */

      /* Apresenta o programa */
   printf( "\n\t>>> Este programa permite que voce jogue"
           "\n\t>>> na Mega-sena sem gastar um centavo."
           "\n\t>>> Em compensacao, a possibilidade de"
           "\n\t>>> voce ficar rico e' zero.\n" );

     /* L a quantidade de nmeros que o usurio apostar */
   printf("\n\t>>> Quantos numeros voce ira' apostar?");
   nApostas = LeIntEntre(NUMEROS_LOTO, MAX_APOSTAS);

   printf("\n\t>>> Digite sua aposta <<<\n");

      /* L aposta do usurio */
   for (i = 0; i < nApostas; ) {
         /* L um nmero da aposta */
      num = LeIntEntre(MENOR_NUMERO_LOTO, MAIOR_NUMERO_LOTO);

         /* Verifica se o usurio j apostou nesse nmero */
      if ( i > 0 && EmArray(aposta, i, num) >= 0 ) {
         printf("\n\t>>> Voce ja' apostou neste numero\n");
      } else {
         aposta[i] = num; /* Nmero ainda no apostado */
            /* O incremento de i  colocado aqui, */
            /* em vez de como expresso do lao   */
            /* for, porque ele  s deve ocorrer   */
            /* quando o nmero no for repetido   */
         ++i;
      }
   }

      /* Inicia o gerador de nmeros aleatrios */
   srand(time(NULL));

      /* Faz o sorteio */
   for (i = 0; i < NUMEROS_LOTO; ++i) {
      sorteio[i] = rand()%MAIOR_NUMERO_LOTO + MENOR_NUMERO_LOTO;
   }

      /* Verifica se o usurio foi sorteado */
   for (i = 0; i < nApostas; ++i) {
         /* Verifica se um nmero sorteado */
         /* faz parte da aposta do usurio */
      if (EmArray(sorteio, NUMEROS_LOTO, aposta[i]) < 0) {
            /* Se o usurio no acertou um dado nmero */
            /* sorteado, ele j perdeu e no adianta   */
            /* verificar os demais nmeros sorteados   */
         perdeu = 1;
         break;
      }
   }

         /* >>> Apresenta os nmeros sorteados <<< */

   printf("\n>>> Os numeros sorteados foram:\n\t");

   for (i = 0; i < NUMEROS_LOTO; ++i) {
      printf("\t%2d", sorteio[i]);
   }

         /* >>> Apresenta os nmeros do usurio <<< */

   printf("\n\n>>> Sua aposta foi:\n\t");

   for (i = 0; i < nApostas; ++i) {
      printf("\t%2d", aposta[i]);
   }

      /* Informa o usurio se ele ganhou ou perdeu */
   if (perdeu) {
      printf("\n\n\t>>> Infelizmente voce nao ganhou.\n");
   } else {
      printf("\n\n\t>>> Parabens! Voce ganhou!"
             "\n\t>>> Agora, seja generoso e divida "
             "o premio com o criador do programa.\n" );
   }

   return 0;
}

/******************* Exemplo de Execuo *******************

        >>> Este programa permite que voce jogue
        >>> na Mega-sena sem gastar um centavo.
        >>> Em compensacao, a possibilidade de
        >>> voce ficar rico e' zero.

        >>> Quantos numeros voce ira' apostar?
        >>> Digite um valor inteiro entre 6 e 15
                > 6

        >>> Digite sua aposta <<<

        >>> Digite um valor inteiro entre 1 e 60
                > 12

        >>> Digite um valor inteiro entre 1 e 60
                > 66

        >>> Valor invalido

        >>> Digite um valor inteiro entre 1 e 60
                > 12

        >>> Voce ja' apostou neste numero

        >>> Digite um valor inteiro entre 1 e 60
                > 3

        >>> Digite um valor inteiro entre 1 e 60
                > 55

        >>> Digite um valor inteiro entre 1 e 60
                > 33

        >>> Digite um valor inteiro entre 1 e 60
                > 22

        >>> Digite um valor inteiro entre 1 e 60
                > 44

>>> Os numeros sorteados foram:
                23      29      48      36      39      33

>>> Sua aposta foi:
                12       3      55      33      22      44

        >>> Infelizmente voce nao ganhou.

***********************************************************/
