/****
 *
 * Exemplo: Esvaziamento do Buffer de Entrada
 *
 * Seo: 11.9.4
 *
 ****/

#include <stdio.h>

void LimpaBuffer(void)
{
   int c; /* Caractere lido */

   do {
      c = getchar();
   } while (c != '\n' && c != EOF);
}

int main(void)
{
   int  umChar, umInt, nValoresLidos;

   printf("\nDigite um valor inteiro: ");
   nValoresLidos = scanf("%d", &umInt);

      /* Verifica se scanf() retornou EOF. */
      /* Se no for o caso, apresenta o    */
      /* resultado e limpa o buffer.       */
   if (nValoresLidos !=  EOF) {
      printf( "\n\t>>> Numero de valores lidos: %d"
              "\n\t>>> Valor lido: %d\n",
              nValoresLidos, umInt );

      LimpaBuffer();
   } else { /* scanf() retornou EOF */
      printf("\n\t>>> Ocorreu erro de leitura\n");
   }

   printf("\nDigite um caractere: ");
   umChar = getchar();

   return 0;
}

/******************* Exemplo de Execuo ******************

Digite um valor inteiro: 345

        >>> Numero de valores lidos: 1
        >>> Valor lido: 345

Digite um caractere: A

**********************************************************/
