/****
 *
 * Exemplo: Esvaziamento do Buffer de Entrada
 *
 * Seo: 11.9.4
 *
 ****/

#include <stdio.h>

void LimpaBuffer(void)
{
   int c; /* Caractere lido */

   do {
      c = getchar();
   } while (c != '\n' && c != EOF);
}

int main(void)
{
   int  umInt, outroInt, nValoresLidos;

   printf("\nDigite um valor inteiro: ");
   nValoresLidos = scanf("%d", &umInt);

      /* Verifica se scanf() retornou EOF.    */
      /* Se no for o caso, limpa o buffer.   */
      /* Se foi lido algum valor, apresenta-o. */
   if (nValoresLidos !=  EOF) {
      LimpaBuffer();

      if (nValoresLidos) {
         printf("Valor lido: %d\n", umInt);
      }
   } else { /* scanf() retornou EOF */
      printf("\n\t>>> Ocorreu erro de leitura\n");
      return 1;
   }

   printf("\nDigite outro valor inteiro: ");
   nValoresLidos = scanf("%d", &outroInt);

      /* Verifica se scanf() retornou EOF */
   if (nValoresLidos ==  EOF) {
      printf("\n\t>>> Ocorreu erro de leitura\n");
      return 1;
   }

   if (nValoresLidos) {
      printf("Valor lido: %d\n", outroInt);
   }

   return 0;
}


/******************* Exemplo de Execuo ******************

Digite um valor inteiro: 123av
Valor lido: 123

Digite outro valor inteiro: 36
Valor lido: 36

**********************************************************/
