/****
 *
 * Exemplo: Processamento Sequencial por Blocos
 *
 * Seo: 11.2.3
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *stream;
   int arInt[] = {1, 2, 3, 4, 5},
       arIntLido[sizeof(arInt)/sizeof(arInt[0])],
       i;

         /* Abre arquivo para escrita em modo binrio */
   if ( !(stream = fopen("Teste", "wb")) ) {
      fprintf(stderr, "\nArquivo nao pode ser aberto\n");
      return 1;
   }

         /* Escreve o array arInt[] no arquivo */
   fwrite( arInt, sizeof(arInt[0]),
           sizeof(arInt)/sizeof(arInt[0]), stream );

      /* Verifica se ocorreu erro de escrita */
   if (ferror(stream)) {
      printf("\nOcorreu erro de escrita de arquivo\n");
      return 1;
   }

      /* Tenta fechar arquivo */
   if (fclose(stream)) {
      fprintf(stderr, "\nArquivo nao pode ser fechado\n");
      return 1;
   }
      /* Abre o arquivo para leitura em modo binrio */
   if ( !(stream = fopen("Teste", "rb")) ) {
      fprintf(stderr, "\nArquivo nao pode ser reaberto\n");
      return 1;
   }

      /* L array no arquivo e armazena-o em arIntLido[] */
   fread( arIntLido, sizeof(arIntLido[0]),
          sizeof(arIntLido)/sizeof(arIntLido[0]), stream );

      /* Verifica se ocorreu erro de leitura */
   if (ferror(stream)) {
      printf("\nOcorreu erro de leitura de arquivo\n");
      return 1;
   }

   printf("\nArray lido no arquivo: { ");

      /* Exibe na tela os elementos do array lido */
   for(i = 0; i < sizeof(arIntLido)/sizeof(arIntLido[0]); ++i) {
      printf("%d, ", arIntLido[i]);
   }

   printf("%d }\n", arIntLido[i]); /* Escreve o ltimo elemento */

   fclose(stream);

   return 0;
}

/****************** Resultado do Programa *****************

Array lido no arquivo: { 1, 2, 3, 4, 5, 1 }

**********************************************************/
