/****
 *
 * Exemplo: Posicionamento do Apontador de Posio
 *
 * Seo: 11.3.1
 *
 * Descrio: Verifica se um stream permite acesso direto
 *
 ****/

#include <stdio.h>

#define NOME_ARQUIVO "Tudor.txt"

int main(void)
{
   FILE  *stream;

      /* Tenta abrir o arquivo em modo */
      /* texto apenas para leitura     */
   stream = fopen(NOME_ARQUIVO, "r");

      /* Checa se arquivo foi aberto */
   if (!stream) {
      printf("\nImpossivel abrir o arquivo %s\n", NOME_ARQUIVO);
      return 1;
   }

      /* Informa se o arquivo recm   */
      /* aberto suporta acesso direto */
   printf( "\n>>> O stream associado a \"%s\" %spermite "
           "acesso direto", NOME_ARQUIVO,
           fseek(stream, 0, SEEK_CUR) ? "NAO " : "" );

      /* Informa se o meio de entrada */
      /* padro suporta acesso direto */
   printf("\n>>> O stream stdin %spermite acesso direto\n",
          fseek(stdin, 0, SEEK_CUR) ? "NAO " : "");

   return 0;
}

/****************** Resultado do Programa ******************

>>> O stream associado a "Tudor.txt" permite acesso direto
>>> O stream stdin NAO permite acesso direto

***********************************************************/
